



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>QTP自传之描述性编程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">QTP自传之描述性编程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 18:37:43 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>描述性编程，即采用描述性的语言定位对象，不需要事先将对象添加到对象库中。下面，就说说如何使用描述性编程，我们将继续使用<a href="http://zlshuo.com/tech/test/494.html" rel="external nofollow noreferrer">对象库编程</a>中的网页。</p>
<h3>使用描述性编程的两种方法</h3>
<ul><li>直接描述</li></ul>
<blockquote><p>对象("属性名:=属性值","属性名:=属性值"...)</p></blockquote>
<p>这种方式很形象很好记，比方说要去找个人，就叫张三吧，用上面的公式就是这样。</p>
<blockquote><p>人("名字:=张三")</p></blockquote>
<p>如果有多个叫张三的人，可以更具体的描述出特征。</p>
<blockquote><p>人("名字:=张三","性别:=男","身高:=175CM"...)</p></blockquote>
<p>通过说出张三的这些特种，最终我们会找到他，下面是我们在<a href="http://zlshuo.com/tech/test/494.html" rel="external nofollow noreferrer">对象库编程</a>使用的代码。</p>
<div>
<pre class="prettyprint linenums">Browser("web对象演示").Page("web对象演示").WebEdit("用户名").Set "test"<br />
Browser("web对象演示").Page("web对象演示").WebEdit("邮箱").Set "11111@qq.com"<br />
Browser("web对象演示").Page("web对象演示").WebEdit("个人介绍").Set "haha"</pre>
</div>
<p>用描述性编程可以达到同样的效果，试试看，用户名是不是输入了test呢？</p>
<div>
<pre class="prettyprint linenums">'描述性编程<br />
Browser("micClass:=Browser").Page("micClass:=Page").WebEdit("name:=username").Set "test"<br />
Browser("micClass:=Browser").Page("micClass:=Page").WebEdit("name:=mail").Set "11111@qq.com"<br />
Browser("micClass:=Browser").Page("micClass:=Page").WebEdit("class:=edit","html tag:=TEXTAREA").Set "haha"</pre>
</div>
<p>注意，对个人介绍富文本使用了两个属性描述，通过网页源码(不想或看不到源码可以通过Spy工具查看对象属性)我们可以看到它没有name属性，而用户名和邮箱的class属性都为edit，要想定位，必须再添加唯一性的属性，这里选择html tag。</p>
<div>
<pre class="prettyprint linenums">//截取的网页源码<br />
&lt;div class="content"&gt;<br />
   &lt;span&gt;用户名&lt;/span&gt;&lt;input type="text" name="username" class="edit"&gt;<br />
&lt;/div&gt;<br />
&lt;div class="content"&gt;<br />
    &lt;span&gt;邮箱&lt;/span&gt;&lt;input type="mail" name="mail"  class="edit"&gt;<br />
&lt;/div&gt;<br />
&lt;div class="content"&gt;<br />
    &lt;span&gt;个人介绍&lt;/span&gt;&lt;textarea rows="5" cols="20" class="edit"&gt;&lt;/textarea&gt;<br />
&lt;/div&gt;</pre>
</div>
<p>大家有没有注意，描述性编程有的时候不能直接从代码上看出所描述对象的具体用途，比如上面代码WebEdit("class:=edit","html tag:=TEXTAREA")，通过class和html tag属性描述，但是我们不知道它描述的什么对象，而对象库编程的代码WebEdit("个人介绍")，清楚的指出这是设置个人介绍输入框的值，这也算是描述性编程不足的地方吧。</p>
<ul><li>Description对象方法</li></ul>
<p>直接上代码</p>
<div>
<pre class="prettyprint linenums"> '描述性编程description方式<br />
 '生成description对象<br />
 Set obj_browser=description.Create()<br />
 Set obj_page=description.Create()<br />
 Set obj_webedit_username=description.Create()<br />
 Set obj_webedit_mail=description.Create()<br />
 Set obj_webedit_textarea=description.Create()<br />
 '设置属性值<br />
 obj_browser("micClass").value="Browser"<br />
 obj_page("micClass").value="Page"<br />
 obj_webedit_username("name").value="username"<br />
 obj_webedit_mail("name").value="mail"<br />
 obj_webedit_textarea("html tag").value="TEXTAREA"

 Browser(obj_browser).Page(obj_page).WebEdit(obj_webedit_username).Set "test"<br />
 Browser(obj_browser).Page(obj_page).WebEdit(obj_webedit_mail).Set "11111@qq.com"<br />
 Browser(obj_browser).Page(obj_page).WebEdit(obj_webedit_textarea).Set  "haha"

 '释放对象<br />
 Set obj_browser=nothing<br />
 Set obj_page=nothing<br />
 Set obj_webedit_username=nothing<br />
 Set obj_webedit_mail=nothing<br />
 Set obj_webedit_textarea=nothing</pre>
</div>
<p>这样写看上去挺好，但当有很多相同对象的时候就会很麻烦，有100个WebEdit难道要设置100个description对象？我们可以改进代码如下</p>
<div>
<pre class="prettyprint linenums"> '描述性编程description方式<br />
 '生成description对象<br />
 Set obj_browser=description.Create()<br />
 Set obj_page=description.Create()<br />
 Set obj_webedit=description.Create()

 '设置属性值<br />
 obj_browser("micClass").value="Browser"<br />
 obj_page("micClass").value="Page"<br />
 obj_webedit("micClass").value="WebEdit"

 Set obj_webedits=Browser(obj_browser).Page(obj_page).ChildObjects(obj_webedit)

 obj_webedits.item().set "test"<br />
 obj_webedits.item().set "11111@qq.com"<br />
 obj_webedits.item().set "haha"

 '释放对象<br />
 Set obj_browser=nothing<br />
 Set obj_page=nothing<br />
 Set obj_webedit=nothing<br />
 Set obj_webedits=nothing</pre>
</div>
<p>两种方式都已经介绍完了，第一种方式适用于一般的测试环境，第二种方式适用于基于框架的测试因其代码的复用性较高，具体的区别大家可以自己体会。下面用两种描述性编程方式重写对象库编程的代码。</p>
<div>
<pre class="prettyprint linenums"> '描述性编程description方式<br />
 '生成description对象<br />
 Set obj_browser=description.Create()<br />
 Set obj_page=description.Create()<br />
 Set obj_webedit=description.Create()<br />
 Set obj_weblist=description.Create()<br />
 Set obj_webcheckbox=description.Create()<br />
 Set obj_webradiogroup=description.Create()<br />
 Set obj_webbutton=description.Create()<br />
 Set obj_webtabe=description.Create()

 '设置属性值<br />
 obj_browser("micClass").value="Browser"<br />
 obj_page("micClass").value="Page"<br />
 obj_webedit("micClass").value="WebEdit"<br />
 obj_weblist("micClass").value="WebList"<br />
 obj_webcheckbox("micClass").value="WebCheckBox"<br />
 obj_webradiogroup("micClass").value="WebRadioGroup"<br />
 obj_webbutton("micClass").value="WebButton"<br />
 obj_webtabe("micClass").value="WebTable"

 '获取所有WebEdit对象<br />
 Set obj_webedits=Browser(obj_browser).Page(obj_page).ChildObjects(obj_webedit)<br />
 obj_webedits.item().set "test"<br />
 obj_webedits.item().set "11111@qq.com"<br />
 obj_webedits.item().set "haha"

 Browser(obj_browser).Page(obj_page).WebList(obj_weblist).Select "java"

 '获取所有WebCheckBox对象<br />
 Set obj_webcheckboxs=Browser(obj_browser).Page(obj_page).ChildObjects(obj_webcheckbox)<br />
 For i= to<br />
     obj_webcheckboxs.item(i).set "ON"<br />
 Next

 Browser(obj_browser).Page(obj_page).WebRadioGroup(obj_webradiogroup).Select "男"<br />
 Browser(obj_browser).Page(obj_page).WebButton(obj_webbutton).Click

 '获取WebTable单元格内的值<br />
 username=Browser(obj_browser).Page(obj_page).WebTable(obj_webtabe).GetCellData(,)<br />
 mail=Browser(obj_browser).Page(obj_page).WebTable(obj_webtabe).GetCellData(,)<br />
 sex=Browser(obj_browser).Page(obj_page).WebTable(obj_webtabe).GetCellData(,)

 If username="test" and mail="11111@qq.com" and sex="男" Then<br />
     msgbox "OK"<br />
 End If<br />
 '释放对象<br />
 Set obj_browser=nothing<br />
 Set obj_page=nothing<br />
 Set obj_webedit=nothing<br />
 Set obj_webedits=nothing<br />
 Set obj_weblist=nothing<br />
 Set obj_webcheckbox=nothing<br />
 Set obj_webradiogroup=nothing<br />
 Set obj_webbutton=nothing<br />
 Set obj_webcheckboxs=nothing<br />
 Set obj_webtabe=nothing<br />
 '描述性编程直接描述方式

 With Browser("micClass:=Browser").Page("micClass:=Page")<br />
     .WebEdit("name:=username").Set "test"<br />
     .WebEdit("name:=mail").Set "11111@qq.com"<br />
     .WebEdit("class:=edit","html tag:=TEXTAREA").Set "haha"<br />
     .WebList("micClass:=WebList").Select "java"<br />
     .WebCheckBox("html id:=film").Set "ON"<br />
     .WebCheckBox("html id:=game").Set "ON"<br />
     .WebRadioGroup("micClass:=WebRadioGroup").Select "男"<br />
     .WebButton("name:=提交").Click

     username=.WebTable("micClass:=WebTable").GetCellData(,)<br />
     mail=.WebTable("micClass:=WebTable").GetCellData(,)<br />
     sex=.WebTable("micClass:=WebTable").GetCellData(,)<br />
 End With

 If username="test" and mail="11111@qq.com" and sex="男" Then<br />
     msgbox "OK"<br />
 End If</pre>
</div>
<h3>如何取舍</h3>
<ul><li>对象库编程</li></ul>
<p>1.当对象的属性有更改时(例如对象name更改)，而脚本中大量引用此对象(10次，100次)，只需要更改对象库中对象的属性即可，描述性编程则需要手动更改所有涉及的代码，效率很低。</p>
<p>2.可以通过对象拖拽，F7等方式快速编写代码，自动生成，不容易打错。</p>
<ul><li>描述性编程</li></ul>
<p>1.不需要维护庞大的对象库。</p>
<p>2.在完成对象库编程不能完成的功能(对象不能识别的时候)</p>
<p>描述性编程和对象库编程各有优缺点，不能说谁好谁劣，只有在适当的时候采用适当的方法才是正理。</p>
<p>最好的方法就是，对象可以识别的时候就用对象库编程，不能识别的时候就用描述性编程。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdm57jq.html">阿里云服务器配置 SVN 服务器与生产站点同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ymy4nq.html">【英语】Bingo口语笔记&lpar;61&rpar; - mind系列</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12p3j9.html">geusture for chrome cfg</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdegooj9.html">css尖角</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vk3p48.html">Microsoft Dynamics CRM 数据库连接存储位置在哪里 是在注册表里</a>
		</li>
						<li><a href="https://www.batexi.com/a/950x1m08.html">Twenty Newsgroups Classification任务之二seq2sparse（5）</a>
		</li>
						<li><a href="https://www.batexi.com/a/950mrn08.html">bootstrap中可用的图标集</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10lwe9.html">MYSQL常用命令2</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pww2oz8.html">【app】Appium日志文件分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllnwz0q.html">JVM垃圾回收机制与内存回收</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gwv0mq.html">docker的常用命令汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdz3709.html">fscanf&lowbar;s与scanf&lowbar;s的宽度参数与缓冲区参数分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy71ymq.html">Ajax - 发送请求原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1o5re9.html">Qt中QSlider的样式表设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyzx2xq.html">Struts2 --简单留言系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllyrg6q.html">工作随笔&mdash;&mdash;pinpoint分布式性能监控工具&lpar;docker安装&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl5oll9.html">JVM内存模型：程序计数器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm2vnw9.html">vue 引入bootstarp --webpack</a>
		</li>
						<li><a href="https://www.batexi.com/a/953zpxv8.html">JAVA非静态成员变量之死循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnzlj3q.html">26&period;OGNL与ValueStack&lpar;VS&rpar;-N语法top语法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96on2g39.html">js分家效应</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdyp6k8.html">cocos2dx 的Hello world的简单分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdyyvl8.html">（转）VS2012网站发布详细步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1kkle9.html">listActivity和ExpandableListActivity的简单用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd3k0gq.html">node http&period;get请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j075m4q.html">IOS DLNA开发（CyberLink和PlatinumKit）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxng7zv8.html">SGU 276 Andrew&amp;&num;39&semi;s Troubles</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1zx459.html">【HOJ1356】【Miller&lowbar;rabin素性测试】Prime Judge</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdevnd79.html">『重构--改善既有代码的设计』读书笔记----Introduce Foreign Method</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zx06z9.html">zoj3839-Poker Face</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
